/*
 * Copyright (c) 2001-2002 Conexant Systems, Inc.
 * 
 * 1.   Permitted use. Redistribution and use in source and binary forms,
 * with or without modification, are permitted under the terms set forth
 * herein.
 * 
 * 2.   Disclaimer of Warranties. CONEXANT AND OTHER CONTRIBUTORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
 * IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
 * CONEXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.
 * 
 * This software has not been formally tested, and there is no guarantee that
 * it is free of errors including, but not limited to, bugs, defects,
 * interrupted operation, or unexpected results. Any use of this software is
 * at user's own risk.
 * 
 * 3.   No Liability.
 * 
 * (a) Conexant or contributors shall not be responsible for any loss or
 * damage to Company, its customers, or any third parties for any reason
 * whatsoever, and CONEXANT OR CONTRIBUTORS SHALL NOT BE LIABLE FOR ANY
 * ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 * WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 * 
 * (b) User agrees to hold Conexant and contributors harmless from any
 * liability, loss, cost, damage or expense, including attorney's fees,
 * as a result of any claims which may be made by any person, including
 * but not limited to User, its agents and employees, its customers, or
 * any third parties that arise out of or result from the manufacture,
 * delivery, actual or alleged ownership, performance, use, operation
 * or possession of the software furnished hereunder, whether such claims
 * are based on negligence, breach of contract, absolute liability or any
 * other legal theory.
 * 
 * 4.   Notices. User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential
 * legends placed upon, contained within or associated with the Software,
 * and shall include all such unaltered copyright, trademark, credits,
 * other proprietary notices or confidential legends on or in every copy of
 * the Software.
 * 
 */

/****************************************************************************************
*                     Version Control Information								
*
*                                                                                       *
* $Header:   P:/d942/octopus/archives/Include/framewrk.h_v   1.29   07 Aug 2002 11:03:54   rayskymy  $
* 
*****************************************************************************************/


/****************************************************************************************

File Name:			framewrk.h	

File Description:	Compiler Directives for code modules

*****************************************************************************************/

/****************************************************************************************
TARGETS SUPPORTED				
TARGET_HCF_PCI_WDM				
TARGET_HCF_PCI_VXD				
TARGET_HCF_USB_WDM				
TARGET_HCF_USB_MACOS9			
TARGET_HCF_USB_MACOSX			
TARGET_HCF_PCI_MACOSX			
TARGET_HCF_PCI_LINUX
TARGET_HCF_USB_LINUX
TARGET_HCF_USB_VXD				
****************************************************************************************/
#ifndef __FRAMEWORK_H__
#define __FRAMEWORK_H__

/****************************************************************************************
	Octopus modem family settings
****************************************************************************************/
#define OCTOPUS_MODEM

/****************************************************************************************
	HCF PCI WDM settings
****************************************************************************************/
#if defined TARGET_HCF_PCI_WDM
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define DIAG_MANAGER
#define VOICE_SUPPORT
//#define TEST_CWCID
//#define BLAM
#if DBG
#define _DEBUG 1
#endif
/****************************************************************************************
	HCF PCI VxD settings
****************************************************************************************/
#elif defined TARGET_HCF_PCI_VXD
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
#define DIAG_MANAGER
//#define BLAM

/****************************************************************************************
	HCF USB WDM settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_WDM
#define FRAMEWORK_HCF_PCI		0
#define FRAMEWORK_HCF_CADMUS2	1
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define MODEM_VXD 0		// for VxD only or VxD/SYS combination
#define MODEM_WDM 1		// WDM modem
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_TEST_SESSION
#define DIAG_MANAGER
//#define BLAM
//#define USE_DCP
#define CADMUS2	1

#if DBG
#define _DEBUG 1
#endif

#define XID_TIMEOUT_RENEG	// rmy: to fix XID rx problem
#define USE_TOTAL_SIGNATURE_CHECK
//#define DP_CLOCK_WA_STAT
//#define LOOPBACK_RETRAIN

/****************************************************************************************
	MacOS9 settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_MACOS9
#define USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_TEST_SESSION
#define FRAMEWORK_HCF_CADMUS2 1
#define CADMUS2	1
#define MACTOPUS
#define _BIG_ENDIAN
#define SAVE_TXRX_STATES
#define USE_DCP
#define FAKE_PULSEDIAL_DCP
#define XID_TIMEOUT_RENEG	// rmy: to fix XID rx problem
//#define DIAG_MANAGER
//#define BLAM

#define _stdcall
#define __stdcall

#define USE_LOOPBACK_RESTART

/****************************************************************************************
	MacOSX settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_MACOSX
#define USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_TEST_SESSION
#define FRAMEWORK_HCF_CADMUS2 1
#define CADMUS2	1
#define MACTOPUS
#define _BIG_ENDIAN
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_DCP
#define FAKE_PULSEDIAL_DCP
#define XID_TIMEOUT_RENEG	// rmy: to fix XID rx problem
#define DIAG_MANAGER
//#define BLAM

#define _stdcall
#define __stdcall

#define USE_LOOPBACK_RESTART

/****************************************************************************************
	MacOSX PCI settings
****************************************************************************************/
#elif defined TARGET_HCF_PCI_MACOSX
#define USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_TEST_SESSION
#define FRAMEWORK_HCF_CADMUS2 0
#define _BIG_ENDIAN
#define MACTOPUS
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_DCP
#define FAKE_PULSEDIAL_DCP
#define XID_TIMEOUT_RENEG	// rmy: to fix XID rx problem
#define DIAG_MANAGER
#define BLAM

#define _stdcall
#define __stdcall

#define USE_LOOPBACK_RESTART

/****************************************************************************************
	HCF PCI LINUX settings
****************************************************************************************/
#elif defined TARGET_HCF_PCI_LINUX
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#undef DIAG_MANAGER
#define VOICE_SUPPORT
#define USE_SMART_DAA
#define FAX34_ENABLE 0
#define SUPPORT_RIPTIDE
#define USE_PRAGMA_PACK 0
//#define TEST_CWCID
//#define BLAM

/****************************************************************************************
	HCF USB LINUX settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_LINUX
#define FRAMEWORK_HCF_PCI		0
#define FRAMEWORK_HCF_CADMUS2	1
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_TEST_SESSION
//#define DIAG_MANAGER
#define USE_PRAGMA_PACK 0
//#define BLAM
//#define USE_DCP
#define CADMUS2	1

#define _stdcall
#define __stdcall

#define XID_TIMEOUT_RENEG	// rmy: to fix XID rx problem
#define USE_TOTAL_SIGNATURE_CHECK
//#define DP_CLOCK_WA_STAT
//#define LOOPBACK_RETRAIN
/****************************************************************************************
	HCF USB VxD settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_VXD
#define FRAMEWORK_HCF_PCI		0
#define FRAMEWORK_HCF_CADMUS2	1
#define MODEM_VXD 1		// for VxD only or VxD/SYS combination
#define MODEM_WDM 0		// WDM modem
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_TEST_SESSION
#define CADMUS2	1
#define DIAG_MANAGER
//#define BLAM

#define XID_TIMEOUT_RENEG	// rmy: to fix XID rx problem
#define USE_TOTAL_SIGNATURE_CHECK
#define USE_LOOPBACK_RESTART

#ifdef DRIVER_VXD			
#define USE_DIRECT_API		// VxD part
#else
#define REMOTE_DRIVER		// SYS part
#endif

#else
#error valid build target not found

#endif	/* TARGET_XXX_YYY_ZZZ */

#if (defined TARGET_HCF_PCI_LINUX || defined TARGET_HCF_USB_LINUX) && defined __GNUC__
// MacOS X compiler, while being GNU C does not like __attribute__((packed))

/* To make structures packed (with no padding), do:
 *    typedef struct PACKED_ATTRIB st_TAG { ... } st_T; */
#define PACKED_ATTRIB __attribute__ ((packed))
#define ALIGNED_ATTRIB(n) __attribute__ ((packed, aligned(n)))
#else
#define PACKED_ATTRIB
#define ALIGNED_ATTRIB(n)
#endif

#endif /* __FRAMEWORK_H__ */
